# For setting DND
$Client_Pre_Command_Handler{'mirtapbx'}{'setastdb'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';

    my ($key,$exten,$data) = split(/~/,$destino);
    if($key eq "fop2state") {

       print "origen $origen destino $destino contexto $contexto key $key exten $exten data $data\n";

        if($data ne "") {

            #$return  = "Action: Command\r\n";
            #$return .= "Command: devstate change Custom:".$exten."-TenantName BUSY\r\n";
            #$return .= "\r\n";
            #push @allreturn, $return;

            $return  = "Action: GetVar\r\n";
            $return .= "Variable: ODBC_FOP2_GET_PEERID($exten-$contexto)\r\n"; 
            $return .= "ActionID: getvar!getidfordnd^on!SIP/$exten-$contexto\r\n";
            $return .= "\r\n";
            push @allreturn, $return;


        } else {

            #$return  = "Action: Command\r\n";
            #$return .= "Command: devstate change Custom:".$exten."-TenantName NOT_INUSE\r\n";
            #$return .= "\r\n";
            #push @allreturn, $return;

            $return  = "Action: GetVar\r\n";
            $return .= "Variable: ODBC_FOP2_GET_PEERID($exten-$contexto)\r\n"; 
            $return .= "ActionID: getvar!getidfordnd^!SIP/$exten-$contexto\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

        }
    }
    return @allreturn;
};

$Client_Pre_Command_Handler{'mirtapbx'}{'queuelogout'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';

    my $server = 0;
    my ( $queue, $posi ) = split( /!/, $origen );

    if ( $queue =~ /(.*)\^(.*)/isx ) {
        $queue  = $1;
        $server = lc($2);
    }

    if($destino =~ /^Local/) {

        my ( undef, undef, undef, $extension ) = split( /-/, $destino );
        my ( $extenid, $context ) = split( /\@/, $extension);

        $return  = "Action: SetVar\r\n";
        $return .= "Variable: ODBC_SET_DEL_QUEUE_MEMBER($extenid)\r\n";
        $return .= "Value: $queue\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: SetVar\r\n";
        $return .= "Variable: ODBC_SET_DEL_QUEUE_MEMBER($queue,$extenid)\r\n";
        $return .= "Value: $queue\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: SetVar\r\n";
        $return .= "Variable: ODBC_FOP2_SET_DEL_QUEUE_MEMBER($queue,$extenid)\r\n";
        $return .= "Value: $queue\r\n";
        $return .= "\r\n";
        push @allreturn, $return;


        # We must send a queue show xxx command in order to refresh caches in asterisk realtime queues 
        # otherwise, the queue member list will not be updated after adding/removing a member
        $return  = "Action: Command\r\n";
        $return .= "Command: queue show $queue\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $timer_refresh = AnyEvent->timer(
            after    => 1,
            cb       => sub {
                $return = "Action: UserEvent\r\n";
                $return .= "UserEvent: REFRESHQUEUE\r\n";
                $return .= "Channel: $queue\r\n\r\n";
                main::send_command_to_managers($return);
            }
        );

    } else {

        my ( $destino, $mypos ) = split( /-/, $destino );

        my $extension = main::get_btn_config( "$contexto", $destino, 'EXTENSION');

        #print "origen $origen destint $destino contexto $contexto mypos $mypos queue $queue server $server extension $extension\n";

        $return  = "Action: GetVar\r\n";
        $return .= "Variable: ODBC_FOP2_GET_PEERID($extension-$contexto)\r\n"; 
        $return .= "ActionID: getvar!getidforqueue^remove!$queue^$extension^$contexto\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

    }

    return @allreturn;
};

$Client_Pre_Command_Handler{'mirtapbx'}{'queueadd'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';

    my $server = 0;
    my ( $queue, $posi ) = split( /!/, $origen );

    if ( $queue =~ /(.*)\^(.*)/isx ) {
        $queue  = $1;
        $server = lc($2);
    }

    my ( $destino, $mypos ) = split( /-/, $destino );

    my $extension = main::get_btn_config( "$contexto", $destino, 'EXTENSION');

    # print "origen $origen destint $destino contexto $contexto mypos $mypos queue $queue server $server extension $extension\n";

    $return  = "Action: GetVar\r\n";
    $return .= "Variable: ODBC_FOP2_GET_PEERID($extension-$contexto)\r\n"; 
    $return .= "ActionID: getvar!getidforqueue^add!$queue^$extension^$contexto\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    return @allreturn;
};


$AMI_Event_Handler{'mirtapbx'}{'USEREVENT'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $userevent   = ${$event}{UserEvent};
    my $family      = ${$event}{Family};
    my $value       = ${$event}{Value};
    my $channel     = FOP2::utils::get_channel(${$event}{Channel});

    if ($userevent =~ /^DND:/) {
        my @partes = split(/:/,$userevent);
        my $extension = $partes[1];
        my $state = $partes[2];

        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Channel: $channel\r\n";
        $return .= "Family: fop2state\r\n";
        if($state eq "on") {
            $return .= "Value: Do not Disturb\r\n";
        } else {
            $return .= "Value: \r\n";
        }
        $return .= "\r\n";
        push @allreturn, $return;

    } 

    if ($userevent eq "GETVAR") {
       if($family =~ /getidfordnd/) {
           @partes = split(/\^/,$family);
           $valdnd=$partes[1];

           $return  = "Action: SetVar\r\n";
           if($valdnd eq "on") {
               $return .= "Variable: ODBC_SET_ENABLE_DND()\r\n";
           } else {
               $return .= "Variable: ODBC_SET_DISABLE_DND()\r\n";
           }
           $return .= "Value: $value\r\n";
           $return .= "\r\n";
           push @allreturn, $return;

       }
       if($family =~ /getidforqueue/) {

           # print "family $family value $value channel $channel\n\n";

           @partes = split(/\^/,$family);
           $queueaction=$partes[1];
           @partes = split(/\^/,$channel);
           $queue = $partes[0];
           $extension = $partes[1];
           $contexto = $partes[2];

           if($queueaction eq "add") {
               #Set(ODBC_SET_ADD_QUEUE_MEMBER(${AGENTNUM},${ODBC_GET_PEERID(${CHANNEL(peername)})},${CHANNEL(peername)})=${APPID});

               $return  = "Action: SetVar\r\n";
               $return .= "Variable: ODBC_SET_ADD_QUEUE_MEMBER($extension,$value,$extension-$contexto)\r\n";
               $return .= "Value: $queue\r\n";
               $return .= "\r\n";
               push @allreturn, $return;

           } else {

                $return  = "Action: SetVar\r\n";
                $return .= "Variable: ODBC_SET_DEL_QUEUE_MEMBER($value)\r\n";
                $return .= "Value: $queue\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return  = "Action: SetVar\r\n";
                $return .= "Variable: ODBC_SET_DEL_QUEUE_MEMBER($queue,$value)\r\n";
                $return .= "Value: $queue\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

           }
     
           # We must send a queue show xxx command in order to refresh caches in asterisk realtime queues 
           # otherwise, the queue member list will not be updated after adding/removing a member
           $return  = "Action: Command\r\n";
           $return .= "Command: queue show $queue\r\n";
           $return .= "\r\n";
           push @allreturn, $return;

           $timer_refresh = AnyEvent->timer(
              after    => 1,
              cb       => sub {
                  $return = "Action: UserEvent\r\n";
                  $return .= "UserEvent: REFRESHQUEUE\r\n";
                  $return .= "Channel: $queue\r\n\r\n";
                  main::send_command_to_managers($return);
              }
           );
       }
    }

    if ($userevent eq "REFRESHQUEUE") {

        if( defined (${$event}{QueueID})) {
            my $queueid       = ${$event}{QueueID};
            $return  = "Action: Command\r\n";
            $return .= "Command: queue show $queueid\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return = "Action: QueueStatus\r\n";
            $return .= "ActionID: initialqueuestatus\r\n";
            $return .= "Queue: $queueid\r\n\r\n";
            push @allreturn, $return;
        } else {
            $return  = "Action: Command\r\n";
            $return .= "Command: queue show $channel\r\n";
            $return .= "\r\n";

            push @allreturn, $return;

            $return = "Action: QueueStatus\r\n";
            $return .= "ActionID: initialqueuestatus\r\n";
            $return .= "Queue: $channel\r\n\r\n";
            push @allreturn, $return;
        }

    }

    return @allreturn;
};

$AMI_Event_Handler{'mirtapbx'}{'FULLYBOOTED'} = sub {

    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    $return = "Action: updateconfig\r\n";
    $return.= "Reload: yes\r\n";
    $return.= "SrcFilename: extensions.conf\r\n";
    $return.= "DstFilename: extensions.conf\r\n";

    $return.= "Action-000000: delcat\r\n";
    $return.= "Cat-000000: fop2-park\r\n";

    $return.= "Action-000001: newcat\r\n";
    $return.= "Cat-000001: fop2-park\r\n";

    $return.= "Action-000002: append\r\n";
    $return.= "Cat-000002: fop2-park\r\n";
    $return.= "Var-000002: exten\r\n";
    $return.= 'Value-000002: _X.,1,Set(ARRAY(RETURN_EXTENSION,RETURN_CONTEXT,PARKBUTTON)=${CUT(EXTEN,:,1)},${CUT(EXTEN,:,2)},${CUT(EXTEN,:,3)})' . "\r\n";

    $return.= "Action-000003: append\r\n";
    $return.= "Cat-000003: fop2-park\r\n";
    $return.= "Var-000003: exten\r\n";
    $return.= 'Value-000003: _X.,2,GotoIf($["${PARKBUTTON}" = "PARK/default"?5)' . "\r\n";

    $return.= "Action-000004: append\r\n";
    $return.= "Cat-000004: fop2-park\r\n";
    $return.= "Var-000004: exten\r\n";
    $return.= 'Value-000004: _X.,3,GotoIf($["${PARKBUTTON}" = ""?5)' . "\r\n";

    $return.= "Action-000005: append\r\n";
    $return.= "Cat-000005: fop2-park\r\n";
    $return.= "Var-000005: exten\r\n";
    $return.= 'Value-000005: _X.,4,Set(PARKINGLOT=${PARKBUTTON:5})' . "\r\n";

    $return.= "Action-000006: append\r\n";
    $return.= "Cat-000006: fop2-park\r\n";
    $return.= "Var-000006: exten\r\n";
    $return.= 'Value-000006: _X.,5,Park(,${RETURN_CONTEXT},${RETURN_EXTENSION},1,s)' . "\r\n";

    $return.= "\r\n";

    push @allreturn, $return;

    return @allreturn;

};

$Client_Pre_Command_Handler{'mirtapbx'}{'queuepause'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my $queue    = $origen;
    my $reason   = '';

    $queue =~ s/QUEUE\///g;

    if ( $destino =~ /!/ ) {
        ( $destino, $reason ) = split( /!/, $destino );
    }

    my $member = $destino;

    if ( FOP2::utils::is_number($member) ) {
        # called from extension button
        my $mirtaidx = main::get_btn_config( "$contexto", $destino, 'QUEUECHANNEL');
        # extract database id from member Local/AG-000-NF-448@fromotherpbx
        $mirtaidx =~ m/^Local\/AG-[^-]*-[^-]*-([^\@]*)(.*)/i ;
        $mirtaidx = $1;

        $return  = "Action: SetVar\r\n";
        $return .= "Variable: ODBC_FOP2_SET_PAUSE_QUEUE_MEMBER($mirtaidx)\r\n";
        $return .= "ActionID: getvar!getidforqueue^pause!$mirtaidx^$contexto\r\n";
        $return .= "Value: $mirtaidx\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

    }
    return @allreturn;
};

$Client_Pre_Command_Handler{'mirtapbx'}{'queueunpause'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my $queue    = $origen;
    my $reason   = '';

    $queue =~ s/QUEUE\///g;

    if ( $destino =~ /!/ ) {
        ( $destino, $reason ) = split( /!/, $destino );
    }

    my $member = $destino;

    if ( FOP2::utils::is_number($member) ) {
        # called from extension button
        my $mirtaidx = main::get_btn_config( "$contexto", $destino, 'QUEUECHANNEL');
        # extract database id from member Local/AG-000-NF-448@fromotherpbx
        $mirtaidx =~ m/^Local\/AG-[^-]*-[^-]*-([^\@]*)(.*)/i ;
        $mirtaidx = $1;

        $return  = "Action: SetVar\r\n";
        $return .= "Variable: ODBC_FOP2_SET_UNPAUSE_QUEUE_MEMBER($mirtaidx)\r\n";
        $return .= "ActionID: getvar!getidforqueue^pause!$mirtaidx^$contexto\r\n";
        $return .= "Value: $mirtaidx\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

    }
    return @allreturn;
};


